(*******************************************************************
This file was generated automatically by the Mathematica front end.
It contains Initialization cells from a Notebook file, which
typically will have the same name as this file except ending in
".nb" instead of ".m".

This file is intended to be loaded into the Mathematica kernel using
the package loading commands Get or Needs.  Doing so is equivalent
to using the Evaluate Initialization Cells menu command in the front
end.

DO NOT EDIT THIS FILE.  This entire file is regenerated
automatically each time the parent Notebook file is saved in the
Mathematica front end.  Any changes you make to this file will be
overwritten.
***********************************************************************)











(* :Name: SelectionBrowser` *)



(******************************************************
SelectionBrowser provides a referring tool to work with one or several notebooks simultaneously. One can add reference to any part of the cell and later can return by its reference button. The package uses the undocumented function of Mathematica CellInformation and does not need to add any changes into the editing notebook! All reference information is stored with reference buttons in the palette SelectionBrowser. To launch the palette execute SelectionBrowser[].
*******************************************************)



(* :Copyright: 2006 by Yuri E. Kandrashkin *)

(* ykandras @ brocku.ca *)

(* 
Permission is granted to use and distribute this package for non-commercial 
non-profit purpose except for inclusion in program collections
The file must remain intact.
*)



BeginPackage["SelectionBrowser`"]

SelectionTag::"usage"=
  "SelectionTag[nb] tags the current selection of NotebookObject nb. SelectionTag[nb] must be executed in a separate notebook."

SelectionFind::"usage"=
  "SelectionFind[nb, tagsel] sets the current selection of NotebookObject nb to be identical to how it was during the execution of a command:\n tagsel = SelectionTag[nb]"

SelectionBrowser::"usage"=
  "SelectionBrowser[] launches the palette to tag any place in the notebook cell (or selection) and to return tagged objects later."

SelectionPositions::"usage"=
  "Option of functions SelectionFind and SelectionBrowser. Determinates the position of a cursor in tagged selection. SelectionPositions->All used to select all referred selection. Values +1 and -1 are used to place the cursor to the left and right positions of the selection. The default option of SelectionBrowser SelectionPositions->Automatic inherits the value of SelectionFind."

Begin["`Private`"]





SelectionTag[]:=
  SelectionTag[EvaluationNotebook[]]

SelectionTag[nb_NotebookObject]:=
  With[
    {info=(LinkWrite[$ParentLink,Global`CellInformation[nb]];
          LinkRead[$ParentLink])},
    If[info===$Failed,$Failed,
      {"CellSerialNumber"/.info,
        ("CursorPosition"/.info)}]]



SelectionFind[pos_,opts___?OptionQ]:=
  SelectionFind[EvaluationNotebook[],{pos},opts]

SelectionFind[nb_NotebookObject,pos_List,opts___?OptionQ]:=
  Module[{currentpos,p1,p2},
      SelectionMove[nb,Before,Notebook,AutoScroll\[Rule]False];
      While[
        SelectionMove[nb,Next,Cell,AutoScroll\[Rule]False];
        currentpos=SelectionTag[nb];
        (currentpos=!=$Failed)&&
          (First[currentpos]=!=First[pos]),
        Null];
      If[currentpos=!=$Failed&&Last[pos]=!={"CellBracket"},
        {p1,p2}=pos\[LeftDoubleBracket]2,1\[RightDoubleBracket];
        SelectionMove[nb,Before,CellContents,AutoScroll\[Rule]False];
        Switch[SelectionPositions/.{opts}/.Options[SelectionFind],
          1,SelectionMove[nb,Next,Character,p1],
          All,SelectionMove[nb,Next,Character,p1];
          Do[FrontEndTokenExecute[nb,"SelectNext"],{p2-p1}],
          _,SelectionMove[nb,Next,Character,p2]];
        nb,$Failed]
      ]/;pos=!=$Failed

Options[SelectionFind]={SelectionPositions\[Rule]All}





tagCell[nb_,sel_]:=
  Module[{shortQ=False,data,str,pos},
    data={nb,sel};
    str=NotebookRead[nb];
    str=str//.h_[val_,pars___]/;h=!=List:>val;
    If[Head[str]===List,str=StringJoin@Flatten@str];
    pos=StringPosition[str,"
        "];
    If[Length[pos]>0,
      shortQ=True;
      str=StringTake[str,pos\[LeftDoubleBracket]1,1\[RightDoubleBracket]-1]];
    If[StringLength[str]>24,
      shortQ=True;
      str=StringTake[str,24]];
    If[shortQ,str=str<>"..."];
    Cell[BoxData@
        GridBox[{{
              ButtonBox[str,ButtonData\[Rule]data],
              ButtonBox[" \[Dash] ",ButtonStyle\[Rule]"DeleteCell"]}}]
      ,"TagCell"]
    ]



tagInsert[]:=
  Module[{},
    btnnb=ButtonNotebook[];
    nb=SelectedNotebook[];
    nbsel=SelectionTag[nb];
    If[nb=!=btnnb,
      nbtag=ToFileName["FileName"/.NotebookInformation[nb]];
      If[StringLength[nbtag]>40,
        nbtag=StringTake[nbtag,15]<>" ... "<>StringTake[nbtag,-25]];
      sel=NotebookFind[btnnb,nbtag,All,CellTags];
      If[sel===$Failed,
        NotebookFind[btnnb,"Main Button",All,CellTags];
        SelectionMove[btnnb,After,Cell];
        NotebookWrite[btnnb,
          Cell[BoxData@
              
              GridBox[{{nbtag,
                    ButtonBox[" \[Dash] ",
                      ButtonStyle\[Rule]"DeleteGroup"]}}],
            "NBSection",CellTags->nbtag]]];
      SelectionMove[btnnb,After,Cell];
      NotebookWrite[btnnb,tagCell[nb,nbsel],All];
      ]]



toNotebookSelection[{nb_,pos_}]:=
  With[{
      selnb=
        SelectionFind[nb,pos,
          SelectionPositions\[Rule]$SelectionBrowserPositions]},
    If[selnb=!=$Failed,SetSelectedNotebook[selnb]]]





stynb=Notebook[{
        Cell[StyleData["Notebook"],
          Active\[Rule]True,
          ButtonBoxOptions\[RuleDelayed]
            {Background\[Rule]RGBColor[0.8,0.9,0.8],
              ButtonFrame\[Rule]"Palette",
              ButtonEvaluator\[Rule]Automatic,
              ButtonFunction\[RuleDelayed](toNotebookSelection[#]&)},
          WindowTitle\[Rule]"Selection Browser",
          WindowFrame->"Palette",
          WindowClickSelect\[Rule]False,
          ShowCellBracket\[Rule]False,
          Saveable\[Rule]False,
          WindowElements\[Rule]{"VerticalScrollBar"},
          WindowSize\[Rule]{FitAll,300},
          Background\[Rule]RGBColor[0.2,0.7,0.7],
          CellFrameMargins\[Rule]0,
          CellMargins\[Rule]{{-1,0},{-1,-1}}],
        
        Cell[StyleData["MainButton"],
          FontSize\[Rule]18,
          FontWeight\[Rule]"Bold",
          GridBoxOptions\[Rule]{
              ColumnWidths\[Rule]12,
              RowMinHeight\[Rule]2},
          CellTags->"Main Button"],
        
        Cell[StyleData["NBSection"],
          CellFrameMargins\[Rule]{{10,1},{0,0}},
          Background\[Rule]RGBColor[0.53,0.81,0.92],
          GridBoxOptions\[Rule]{
              RowAlignments\[Rule]Center,
              ColumnAlignments\[Rule]Left,
              ColumnSpacings\[Rule]0.1,
              ColumnLines\[Rule]0,
              ColumnWidths\[Rule]{16.1,2}},
          CellGroupingRules\[Rule]"SectionGrouping",
          FontFamily\[Rule]"Helvetica",
          FontSize\[Rule]12,
          FontWeight\[Rule]"Bold"],
        
        Cell[StyleData["TagCell"],
          CellMargins\[Rule]{{-2,0},{-1,-1}},
          LanguageCategory\[Rule]Natural,
          CellFrameMargins\[Rule]0,
          ButtonBoxOptions\[Rule]
            {TextAlignment\[Rule]Left,
              Background\[Rule]RGBColor[0.8,0.9,0.8]},
          GridBoxOptions\[Rule]{
              RowAlignments\[Rule]Center,
              ColumnSpacings\[Rule]0.05,
              ColumnLines\[Rule]0.05,
              ColumnWidths\[Rule]{17,2}},
          FontFamily\[Rule]"Helvetica",
          FontSize\[Rule]12],
        
        Cell[StyleData["AddTag"],
          ButtonBoxOptions\[Rule]
            {Background\[Rule]RGBColor[0.2,0.7,0.7],
              ButtonFrame\[Rule]"DialogBox",
              ButtonFunction\[RuleDelayed]{tagInsert[]},
              ButtonEvaluator\[Rule]Automatic}],
        
        Cell[StyleData["DeleteCell"],
          ButtonBoxOptions\[Rule]
            {ButtonFunction\[RuleDelayed]{
                  FrontEnd`SelectionMove[ButtonNotebook[],All,ButtonCell],
                  FrontEnd`NotebookDelete[ButtonNotebook[]]},
              ButtonEvaluator\[Rule]None}],
        
        Cell[StyleData["DeleteGroup"],
          ButtonBoxOptions\[Rule]
            {Background\[Rule]RGBColor[0.53,0.81,0.92],
              ButtonFunction\[RuleDelayed]{
                  FrontEnd`SelectionMove[ButtonNotebook[],All,ButtonCell],
                  FrontEnd`SelectionMove[ButtonNotebook[],All,CellGroup],
                  FrontEnd`NotebookDelete[ButtonNotebook[]]},
              ButtonEvaluator\[Rule]None}]
        }];



SelectionBrowser[opts___?OptionQ]:=
    Module[{},
      $SelectionBrowserPositions=
        SelectionPositions/.{opts}/.Options[SelectionBrowser];
      If[$SelectionBrowserPositions===
          Automatic,$SelectionBrowserPositions=(SelectionPositions/.Options[
                SelectionFind])];
      NotebookPut@Notebook[{
            Cell[BoxData@
                
                GridBox[{{ButtonBox["Add Selection Tag",
                        ButtonStyle\[Rule]"AddTag"]}}],
              "MainButton"]},
          WindowMargins\[Rule]{{Automatic,0},{Automatic,0}},
          StyleDefinitions\[Rule]stynb]];

Options[SelectionBrowser]={SelectionPositions\[Rule]Automatic}



Protect[SelectionTag,SelectionFind,SelectionBrowser]

End[]
EndPackage[]