(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 5.1'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[      6156,        225]*)
(*NotebookOutlinePosition[      6840,        248]*)
(*  CellTagsIndexPosition[      6796,        244]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell["SelectionBrowser Installation", "Section"],

Cell[CellGroupData[{

Cell["About", "Subsection"],

Cell[TextData[{
  StyleBox["SelectionBrowser", "MR"],
  " provides a referring tool to work with one or several notebooks \
simultaneously. One can add reference to any part of the cell and later can \
return by its reference button. The package uses the undocumented function of \
",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " ",
  StyleBox["CellInformation", "MR"],
  " and does not need to add any changes into the editing notebook! All \
reference information is stored with reference buttons in the palette ",
  StyleBox["SelectionBrowser", "SR"],
  ". To launch the palette execute ",
  StyleBox["SelectionBrowser[]", "MR"],
  "."
}], "Text"],

Cell["\[Copyright] Yuri E. Kandrashkin, 2006", "Text",
  TextAlignment->Right]
}, Open  ]],

Cell[CellGroupData[{

Cell["Installation", "Subsection"],

Cell[CellGroupData[{

Cell["Find the installation directory", "Subsubsection"],

Cell["\<\
Evaluate the following cell to get user base directory on your system: \
\>", "Text"],

Cell[BoxData[{
    \($BaseDirectory\), "\[IndentingNewLine]", 
    \($UserBaseDirectory\)}], "Input"],

Cell["This gives the folders where the package can be placed.", "Text"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Copy files to a selected directory", "Subsubsection"],

Cell[TextData[{
  "If previous version of ",
  StyleBox["SelectionBrowser", "MR"],
  " was installed remove its folder. Unpack and copy the directory ",
  StyleBox["SelectionBrowser", "MR"],
  " into ",
  StyleBox["Applications", "MR"],
  " subdirectory of ",
  StyleBox["$BaseDirectory", "MR"],
  " or ",
  StyleBox["$UserBaseDirectory", "MR"],
  ". \nThis allows loading the package through its context name or short \
path:"
}], "Text"],

Cell[BoxData[
    \(Needs["\<SelectionBrowser\>"]\)], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Rebuild Help Index", "Subsubsection"],

Cell[TextData[{
  "Execute the menu command ",
  StyleBox["Help \[RightTriangle] Rebuild Help Index", "SR"]
}], "Text"],

Cell[TextData[{
  "This adds ",
  StyleBox["SelectionBrowser", "MR"],
  " help file in ",
  StyleBox["Help", "SR"],
  " ",
  StyleBox["Browser", "SR"],
  "."
}], "Text"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Add menu and keyboard shortcut command", "Subsubsection"],

Cell[TextData[{
  StyleBox["OptionsExplorer", "MR"],
  " needs menu command to be added in file ",
  StyleBox["MenuSetup.tr", "MR"],
  ". To get path to this file evaluate next cell ",
  "(for OS Windows)",
  ":"
}], "Text"],

Cell[BoxData[
    \(ToFileName[{$TopDirectory, "\<SystemFiles\>", "\<FrontEnd\>", \
"\<TextResources\>", "\<Windows\>"}]\)], "Input"],

Cell[TextData[{
  "Create the subdirectories in the same order in your base directory and \
copy the file ",
  StyleBox["MenuSetup.tr", "MR"],
  " there. Insert the following lines after the ",
  StyleBox["Item[\"Make Inde&x...\",...]", "MR"],
  ":"
}], "Text"],

Cell[TextData[StyleBox[" \t, \n\tDelimiter,\n\tItem[\"Selection &Browser\", \
KernelExecute[ToExpression[\"SelectionBrowser[]\"]],\n \t\
MenuKey[\"f\",Modifiers->{Control,Command}], MenuEvaluator->Automatic]", \
"MR"]], "Text",
  CellFrame->True],

Cell[TextData[{
  "and restart ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  ".  "
}], "Text"],

Cell[TextData[{
  "This adds new menu item ",
  StyleBox["Input \[RightTriangle] Selection Browser", "SR"],
  " and sets keyboard shortcut \[AltKey]",
  StyleBox["\[KeyBar]", "MR"],
  "\[ControlKey]\[LeftModified]f\[RightModified] (for Windows). The command \
opens ",
  StyleBox["SelectionBrowser", "MR"],
  " dialog window."
}], "Text"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Make autoloading package", "Subsubsection"],

Cell[TextData[{
  "Save in the directory ",
  StyleBox["Kernel", "MR"],
  " of your ",
  StyleBox["$BaseDirectory", "MR"],
  " or ",
  StyleBox["$UserBaseDirectory", "MR"],
  " the file ",
  StyleBox["init.m", "MR"],
  " with the following line (or add this line if the file ",
  StyleBox["init.m", "MR"],
  " already exists):"
}], "Text"],

Cell[TextData[StyleBox["\tNeeds[\"SelectionBrowser`\"]", "MR"]], "Text",
  CellFrame->True],

Cell[TextData[{
  "This allows the package to load with the ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " kernel. "
}], "Text"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
FrontEndVersion->"5.1 for Microsoft Windows",
ScreenRectangle->{{0, 1400}, {0, 971}},
WindowSize->{496, 740},
WindowMargins->{{251, Automatic}, {Automatic, 78}},
StyleDefinitions -> "HelpBrowser.nb"
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1776, 53, 48, 0, 65, "Section"],

Cell[CellGroupData[{
Cell[1849, 57, 27, 0, 39, "Subsection"],
Cell[1879, 59, 661, 16, 110, "Text"],
Cell[2543, 77, 78, 1, 25, "Text"]
}, Open  ]],

Cell[CellGroupData[{
Cell[2658, 83, 34, 0, 39, "Subsection"],

Cell[CellGroupData[{
Cell[2717, 87, 56, 0, 35, "Subsubsection"],
Cell[2776, 89, 95, 2, 25, "Text"],
Cell[2874, 93, 101, 2, 49, "Input"],
Cell[2978, 97, 71, 0, 25, "Text"]
}, Open  ]],

Cell[CellGroupData[{
Cell[3086, 102, 59, 0, 35, "Subsubsection"],
Cell[3148, 104, 439, 13, 84, "Text"],
Cell[3590, 119, 62, 1, 29, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[3689, 125, 43, 0, 35, "Subsubsection"],
Cell[3735, 127, 119, 3, 25, "Text"],
Cell[3857, 132, 169, 8, 25, "Text"]
}, Open  ]],

Cell[CellGroupData[{
Cell[4063, 145, 63, 0, 35, "Subsubsection"],
Cell[4129, 147, 224, 7, 42, "Text"],
Cell[4356, 156, 133, 2, 49, "Input"],
Cell[4492, 160, 261, 7, 59, "Text"],
Cell[4756, 169, 246, 4, 150, "Text"],
Cell[5005, 175, 105, 5, 25, "Text"],
Cell[5113, 182, 338, 9, 42, "Text"]
}, Open  ]],

Cell[CellGroupData[{
Cell[5488, 196, 49, 0, 35, "Subsubsection"],
Cell[5540, 198, 339, 12, 59, "Text"],
Cell[5882, 212, 91, 1, 41, "Text"],
Cell[5976, 215, 140, 5, 25, "Text"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

